/*
 * Copyright (C) 2017-2020 TENCENT Inc.All Rights Reserved.
 * FileName：VRBKrpanoInterface.js
 * Description：
 *
 * History：
 * 1.0 jackieluo 2017年10月19日 Create
 * Latest:
 * 2017-10-24 15:34
 */
var require, define;
//匿名函数声明完就立即执行
!function (global) {
    if (!require) {
        var head = document.getElementsByTagName("head")[0]
            , loadingMap = {}
            , factoryMap = {}
            , modulesMap = {}
            , scriptsMap = {}
            , resMap = {}
            , pkgMap = {}
            , createScript = function (url, onerror) {
                if (!(url in scriptsMap)) {
                    scriptsMap[url] = !0;
                    var script = document.createElement("script");
                    if (onerror) {
                        var tid = setTimeout(onerror, require.timeout);
                        script.onerror = function () {
                            clearTimeout(tid),
                                onerror()
                        }
                        ;
                        var onload = function () {
                                clearTimeout(tid)
                            }
                        ;
                        "onload" in script ? script.onload = onload : script.onreadystatechange = function () {
                            ("loaded" === this.readyState || "complete" === this.readyState) && onload()
                        }
                    }
                    return script.type = "text/javascript",
                        script.src = url,
                        head.appendChild(script),
                        script
                }
            }
            , loadScript = function (id, callback, onerror) {
                var queue = loadingMap[id] || (loadingMap[id] = []);
                queue.push(callback);
                var url, res = resMap[id] || resMap[id + ".js"] || {}, pkg = res.pkg;
                url = pkg ? pkgMap[pkg].url || pkgMap[pkg].uri : res.url || res.uri || id,
                    createScript(url, onerror && function () {
                            onerror(id)
                        }
                    )
            }
        ;
        define = function (id, factory) {
            id = id.replace(/\.js$/i, ""),
                factoryMap[id] = factory;
            var queue = loadingMap[id];
            if (queue) {
                for (var i = 0, n = queue.length; n > i; i++)
                    queue[i]();
                delete loadingMap[id]
            }
        }
            ,
            require = function (id) {
                if (id && id.splice)
                    return require.async.apply(this, arguments);
                id = require.alias(id);
                var mod = modulesMap[id];
                if (mod)
                    return mod.exports;
                var factory = factoryMap[id];
                if (!factory)
                    throw "[ModJS] Cannot find module `" + id + "`";
                mod = modulesMap[id] = {
                    exports: {}
                };
                var ret = "function" == typeof factory ? factory.apply(mod, [require, mod.exports, mod]) : factory;
                return ret && (mod.exports = ret),
                    mod.exports
            }
            ,
            require.async = function (names, onload, onerror) {
                function findNeed(depArr) {
                    for (var child, i = 0, n = depArr.length; n > i; i++) {
                        var dep = require.alias(depArr[i]);
                        dep in factoryMap ? (child = resMap[dep] || resMap[dep + ".js"],
                        child && "deps" in child && findNeed(child.deps)) : dep in needMap || (needMap[dep] = !0,
                                needNum++,
                                loadScript(dep, updateNeed, onerror),
                                child = resMap[dep] || resMap[dep + ".js"],
                            child && "deps" in child && findNeed(child.deps))
                    }
                }

                function updateNeed() {
                    if (0 === needNum--) {
                        for (var args = [], i = 0, n = names.length; n > i; i++)
                            args[i] = require(names[i]);
                        onload && onload.apply(global, args)
                    }
                }

                "string" == typeof names && (names = [names]);
                var needMap = {}
                    , needNum = 0;
                findNeed(names),
                    updateNeed()
            }
            ,
            require.resourceMap = function (obj) {
                var k, col;
                col = obj.res;
                for (k in col)
                    col.hasOwnProperty(k) && (resMap[k] = col[k]);
                col = obj.pkg;
                for (k in col)
                    col.hasOwnProperty(k) && (pkgMap[k] = col[k])
            }
            ,
            require.loadJs = function (url) {
                createScript(url)
            }
            ,
            require.loadCss = function (cfg) {
                if (cfg.content) {
                    var sty = document.createElement("style");
                    sty.type = "text/css",
                        sty.styleSheet ? sty.styleSheet.cssText = cfg.content : sty.innerHTML = cfg.content,
                        head.appendChild(sty)
                } else if (cfg.url) {
                    var link = document.createElement("link");
                    link.href = cfg.url,
                        link.rel = "stylesheet",
                        link.type = "text/css",
                        head.appendChild(link)
                }
            }
            ,
            require.alias = function (id) {
                return id.replace(/\.js$/i, "")
            }
            ,
            require.timeout = 5e3
    }
}
(this);
;

define("widget/siteDetection", function (require, exports, module) {
        function getScreenSplitType() {
            return isDoubleScreenMode === !0 ? "NORMAL_3D_LR" : "NORMAL_2D"
        }

        function getVersion() {
            return "1.0.0.51"
        }

        function isInteractionWithWeb() {
            return isDoubleScreenMode === !0 ? !1 : !0
        }

        var isDoubleScreenMode = !0;
        module.exports = {
            detect: function () {
                var siteName, siteMedia, siteSplit, siteGyro, siteInteraction = !0, delayEnterVR = 0,
                    host = window.location.host;
                switch (console.log("--inject-- siteDetction host detect before=>1 " + host + "   url:" + window.location.href),
                    host) {
                    case "www.youku.com":
                    case "v.youku.com":
                    case "m.youku.com":
                        siteName = "youku",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "c-h5.youku.com":
                        siteName = "youku-h5",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "www.tudou.com":
                        siteName = "tudou",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "m.le.com":
                        siteName = "le",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "www.bilibili.com":
                    case "m.bilibili.com":
                        siteName = "bilibili",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "live.bilibili.com":
                        siteName = "bilibili",
                            siteMedia = "video-live",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "m.tv.sohu.com":
                        siteName = "sohu",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "m.v.qq.com":
                        siteName = "qq",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "m.pptv.com":
                        siteName = "pptv",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "m.iqiyi.com":
                        siteName = "iqiyi",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "v.sina.cn":
                        siteName = "sina",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "m.ku6.com":
                        siteName = "ku6",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "m.56.com":
                        siteName = "56",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "m.kankan.com":
                        siteName = "kankan",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "www.wasu.cn":
                        siteName = "wasu",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "m.mgtv.com":
                        siteName = "mgtv",
                            siteMedia = "video",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "h.huajiao.com":
                        siteName = "huajiao",
                            siteMedia = "video-live",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "m.huya.com":
                        siteName = "huya",
                            siteMedia = "video-live",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "m.douyu.com":
                        siteName = "douyu",
                            siteMedia = "video-live",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "m.panda.tv":
                        siteName = "panda",
                            siteMedia = "video-live",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "m.zhanqi.tv":
                        siteName = "zhanqi",
                            siteMedia = "video-live",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "www.huomao.com":
                        siteName = "huomao",
                            siteMedia = "video-live",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "m.quanmin.tv":
                        siteName = "quanmin",
                            siteMedia = "video-live",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "star.longzhu.com":
                        siteName = "longzhu",
                            siteMedia = "video-live",
                            siteSplit = "NORMAL_2D",
                            siteGyro = "NONE",
                            siteInteraction = !0;
                        break;
                    case "vr.cntraveler.com.cn":
                        siteName = "cntraveler",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "wapbaike.baidu.com":
                    case "baike.baidu.com":
                    case "baikebcs.bdimg.com":
                        siteName = "baike-museum",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "media.detu.com":
                    case "m.detu.com":
                    case "www.detu.com":
                        siteName = "detu",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "www.quanjingke.com":
                        siteName = "quanjingke",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "720yun.com":
                        siteName = "720yun",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "video-player.720yun.com":
                    case "video.qncdn.720yun.com":
                        siteName = "720yun-video",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "www.ivrpano.com":
                    case "video.ivrpano.com":
                        siteName = "ivrpano",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "wechat.hotcast.cn":
                        siteName = "hotcast",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "www.720real.com":
                        siteName = "720real",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "www.yumowang.com":
                        siteName = "yumowang",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "www.new720.com":
                        siteName = "new720",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "www.shiw-vr.com":
                        siteName = "shiw-vr",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb(),
                            delayEnterVR = 3;
                        break;
                    case "www.720ku.com":
                        siteName = "720ku",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "qj.ddmer.com":
                        siteName = "ddmer",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "www.rgbsee.com":
                        siteName = "rgbsee",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "editor.qjzone.com":
                        siteName = "qjzone",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                        break;
                    case "m.vrsmash.com":
                        siteName = "vrsmash",
                            siteMedia = "video";
                        var vedioType = document.getElementById("video_html5_api").getAttribute("type");
                        null != vedioType && vedioType.length > 0 && (vedioType.indexOf("180-lr") >= 0 ? (siteSplit = "PANORAMA180_LR",
                            siteMedia = "PANORAMA_VIDEO") : vedioType.indexOf("360-tb") >= 0 && (siteSplit = "NORMAL_3D_TB",
                                siteMedia = "PANORAMA_VIDEO")),
                            siteGyro = "OUTSIDE_CONTROLLER",
                            siteInteraction = !0
                        break;
                    case "www.expoon.com":
                        siteName = "expoon",
                            siteMedia = "vr",
                            siteSplit = getScreenSplitType(),
                            siteGyro = "WEB_INNER",
                            siteInteraction = isInteractionWithWeb();
                }
                return console.log("--inject-- siteDetction detect host after=>2 " + siteName + siteMedia + siteSplit + siteGyro),
                    siteName = siteName || null ,
                    siteMedia = siteMedia || "NONE",
                    siteSplit = siteSplit || "NONE",
                    siteGyro = siteGyro || "NONE",
                    console.log("--inject-- siteDetction siteMedia after=>3 " + siteName + siteMedia + siteSplit + siteGyro),
                    getVersion(),
                    console.log("--inject-- siteDetction getVersion() =>4 " + getVersion()),
                    {
                        siteName: siteName,
                        siteMedia: siteMedia,
                        siteSplit: siteSplit,
                        siteGyro: siteGyro,
                        siteInteraction: siteInteraction,
                        delayEnterVR: delayEnterVR
                    }
            },
            isDoubleScreenMode: function () {
                return isDoubleScreenMode
            }
        }
    }
);
define("widget/webvr", function (require, exports, module) {
    function detect() {
        var mediaType;
        if (console.log("--inject-- webvr detect begin =>1"),
                krpanoContainer) {
            var krpanoObj = document.getElementById(krpanoContainer);
            if (krpanoObj) {
                mediaType = "PANORAMA_PICTURE",
                    console.log("--inject-- webvr detect init PANORAMA_PICTURE =>2 " + krpanoObj.get(krpanoWebVRPlugin));
                var krpanoPlugin = krpanoObj.get && krpanoObj.get("plugin");
                if (krpanoPlugin) {
                    var krpanoPluginVideo = krpanoPlugin.getItem && krpanoPlugin.getItem("video");
                    krpanoPluginVideo && (console.log("--inject-- webvr detect set PANORAMA_VIDEO =>3 "),
                        mediaType = "PANORAMA_VIDEO")
                }
            }
            return "function" == typeof initLoad && (console.log("--inject-- webvr detect initLoad PANORAMA_VIDEO =>4 "),
                mediaType = "PANORAMA_VIDEO"),
                mediaType = mediaType || "NONE",
                console.log("--inject-- webvr detect return =>5 " + mediaType),
                mediaType
        }
    }

    function bindEvents() {
        var krpanoObj = document.getElementById(krpanoContainer)
            , krpanoWebVR = krpanoObj.get && krpanoObj.get(krpanoWebVRPlugin);
        krpanoWebVR && krpanoWebVR.onentervr && (console.log("--inject-- webvr krpanoWebVR.onentervr set" + krpanoWebVR.onentervr),
                krpanoWebVR.onentervr = krpanoWebVR.onentervr + ";js(onEnterVR();)"
                , krpanoWebVR.onexitvr = krpanoWebVR.onexitvr + ";js(onExitVR();)"
        )
        if (navigator.userAgent.indexOf('iPhone') !== -1) { // iOS
            try {
                window.webkit.messageHandlers.vrbEventHandler.postMessage("onWebvrInit");
                console.log('messageHandlers:', window.webkit.messageHandlers);
            } catch (err) {
                console.log(err)
            }
        } else if (navigator.userAgent.indexOf('Android') !== -1) { // Android
            try {
                window.vrbEventHandler.onWebvrInit();
                console.log('vrbEventHandler:', window.vrbEventHandler);
            } catch (err) {
                console.log(err);
            }
        } else {
            alert('非法操作');
        }
    }

    function init() {
        console.log("bindEvents");
        var krpanoObj = document.getElementById(krpanoContainer);
        if (krpanoObj) {
            var krpanoWebVR = krpanoObj.get && krpanoObj.get(krpanoWebVRPlugin);
            if (null === krpanoWebVR)
                var count = 0
                    , timer = setInterval(function () {
                        return console.log("--inject-- webvr init timer:" + count),
                            krpanoWebVR = krpanoObj.get && krpanoObj.get(krpanoWebVRPlugin),
                            null === krpanoWebVR ? void (5 > count ? count++ : clearInterval(timer)) : (clearInterval(timer),
                                void bindEvents())
                    }
                    , 3e3);
            else
                bindEvents()
        } else {
            if (navigator.userAgent.indexOf('iPhone') !== -1) { // iOS
                try {
                    window.webkit.messageHandlers.vrbEventHandler.postMessage("onWebvrInitFailed");
                } catch (err) {
                    console.log(err)
                }
            } else if (navigator.userAgent.indexOf('Android') !== -1) { // Android
                try {
                    window.vrbEventHandler.onWebvrInitFailed();
                } catch (err) {
                    console.log(err);
                }
            } else {
                console.log('no receiver');
            }
        }
    }

    function start() {
        var krpanoObj = document.getElementById(krpanoContainer);
        if (krpanoObj && krpanoPluginGyro && krpanoObj.get && krpanoObj.get("plugin[" + krpanoPluginGyro + "]") && !krpanoObj.get("plugin[" + krpanoPluginGyro + "]").enabled) {
            var gap = 1e3
                , count = 0
                , timer = "";
            clearTimeout(timer),
                krpanoObj.set("plugin[" + krpanoPluginGyro + "].enabled", !0),
                count += 1
        } else
            console.log("second"),
            5 > count && (timer = setTimeout(function () {
                    start(krpanoObj),
                        console.log("timer")
                }
                , gap))
    }

    function doubleScreenExecute() {
        console.log("--inject-- webvr doubleScreenExecute siteName:" + siteName + " " + krpanoContainer + " " + krpanoWebVRPlugin + " url:" + window.location.href);
        var krpanoObj = document.getElementById(krpanoContainer)
            , krpanoWebVR = krpanoObj.get && krpanoObj.get(krpanoWebVRPlugin);
        console.log("--inject-- webvr object info" + krpanoObj + " " + krpanoObj.get + " " + krpanoObj.get(krpanoWebVRPlugin) + " " + krpanoObj.get(krpanoWebVRPlugin)),
        krpanoWebVR && krpanoWebVR.onentervr && (console.log("--inject-- webvr krpanoWebVR.onentervr set" + krpanoWebVR.onentervr),
            krpanoWebVR.onentervr = krpanoWebVR.onentervr + "; vr_setup_close();"),
        krpanoWebVR && krpanoWebVR.entervr && (console.log("--inject-- webvr krpanoWebVR.entervr：" + krpanoWebVR.entervr),
            krpanoWebVR.entervr(),
        0 !== siteName.delayEnterVR && setTimeout(function () {
                krpanoWebVR.entervr();
            }
            , siteName.delayEnterVR))
    }

    function doubleScreenModeExecute() {
        var krpanoObj = document.getElementById(krpanoContainer);
        if (krpanoObj) {
            var krpanoWebVR = krpanoObj.get && krpanoObj.get(krpanoWebVRPlugin);
            if (null === krpanoWebVR)
                var count = 0
                    , timer = setInterval(function () {
                        return console.log("--inject-- webvr doubleScreenModeExecute timer:" + count),
                            krpanoWebVR = krpanoObj.get && krpanoObj.get(krpanoWebVRPlugin),
                            null === krpanoWebVR ? void (5 > count ? count++ : clearInterval(timer)) : (clearInterval(timer),
                                void doubleScreenExecute())
                    }
                    , 3e3);
            else
                doubleScreenExecute()
        }
    }

    var krpanoContainer, krpanoPluginGyro, originExitBTLayer, originSetupBTLayer, utovrGyroFunc,
        siteDetection = require("widget/siteDetection"),
        siteObj = siteDetection.detect(), siteName = siteObj.siteName, krpanoWebVRPlugin = "webvr";
    switch (siteName) {
        case "cntraveler":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "skin_gyro";
            break;
        case "baike-museum":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "gyro";
            break;
        case "detu":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "gyro";
            break;
        case "quanjingke":
            krpanoContainer = "qjkpano",
                krpanoPluginGyro = "skin_gyro";
            break;
        case "720yun-video":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "gyroplugin",
                utovrGyroFunc = function () {
                    setTimeout(function () {
                            var event = document.createEvent("Events");
                            event.initEvent("touchend", !0, !0),
                            document.getElementById("videoDragToggle") && document.getElementById("videoDragToggle").dispatchEvent(event)
                        }
                        , 1e3)
                }
            ;
        case "720yun":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "gyroplugin",
                originExitBTLayer = "webvr_exitbutton",
                originSetupBTLayer = "webvr_setupbutton";
            break;
        case "ivrpano":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "skin_gyro";
            break;
        case "le":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "gyro",
            document.getElementById("guide_layer") && (document.getElementById("guide_layer").style.display = "none");
            break;
        case "hotcast":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "gyro";
            break;
        case "720real":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "gyro";
            break;
        case "yumowang":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "gyro";
            break;
        case "new720":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "gyro";
            break;
        case "shiw-vr":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "gyro";
            break;
        case "720ku":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "gyro";
            break;
        case "ddmer":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "gyro";
            break;
        case "rgbsee":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "gyro";
            break;
        case "qjzone":
            krpanoContainer = "krpanoSWFObject",
                krpanoPluginGyro = "gyro"
        case "expoon":
            krpanoContainer = "expoonPano",
                krpanoPluginGyro = "gyro",
                originExitBTLayer = "webvr_exitbutton",
                originSetupBTLayer = "webvr_setupbutton";
    }
    console.log("--inject-- webvr switch => siteName:" + siteName + " " + krpanoContainer + " " + krpanoPluginGyro + " " + krpanoWebVRPlugin),
        module.exports = {
            detect: function () {
                return detect()
            },
            init: function () {
                return init()
            },
            play: function () {
                var mediaType = detect();
                if (console.log("<**> --inject-- webvr play =>" + mediaType),
                    "PANORAMA_VIDEO" === mediaType && krpanoContainer) {
                    var krpanoObj = document.getElementById(krpanoContainer);
                    krpanoObj && krpanoObj.call("plugin[video].play()")
                }
            },
            pause: function () {
                var mediaType = detect();
                if ("PANORAMA_VIDEO" === mediaType && krpanoContainer) {
                    var krpanoObj = document.getElementById(krpanoContainer);
                    krpanoObj && krpanoObj.call("plugin[video].pause()")
                }
            },
            enterFullScreen: function (mediaType) {
                if (console.log("<**> --inject-- webvr enterFullScreen =>" + mediaType),
                        krpanoContainer) {
                    var isDoubleScreenMode = siteDetection.isDoubleScreenMode();
                    if (isDoubleScreenMode) {
                        doubleScreenModeExecute();
                    } else {
                        start(),
                        utovrGyroFunc && utovrGyroFunc();
                        var krpanoObj = document.getElementById(krpanoContainer);
                        krpanoObj && !krpanoObj.get("fullscreen") && krpanoObj.set("fullscreen", !0);
                    }
                }
            },
            exitFullScreen: function (mediaType) {
                if (console.log("<**> --inject-- webvr exitFullScreen =>" + mediaType),
                        krpanoContainer) {
                    var krpanoObj = document.getElementById(krpanoContainer)
                    var isDoubleScreenMode = siteDetection.isDoubleScreenMode();
                    if (isDoubleScreenMode) {
                        var krpanoWebVR = krpanoObj.get && krpanoObj.get(krpanoWebVRPlugin);
                        krpanoWebVR.exitvr();
                    } else {
                        krpanoObj && krpanoObj.get("fullscreen") && krpanoObj.set("fullscreen", !1);
                    }

                }
            },
            addHotspots: function (mediaType) {
                if (console.log("<**> --inject-- webvr addHotspots =>" + mediaType),
                        krpanoContainer) {
                    var krpanoObj = document.getElementById(krpanoContainer);
                    if (krpanoObj) {
                        var h = krpanoObj.get("view.hlookat");
                        var v = krpanoObj.get("view.vlookat");
                        // var hs_name = "hs" + ((Date.now() + Math.random()) | 0); // create unique/randome name
                        var hs_name = "vrb_back_bt";
                        krpanoObj.call("addhotspot(" + hs_name + ")");
                        krpanoObj.set("hotspot[" + hs_name + "].url", "http://3gimg.qq.com/trom_s/vrbrowser/h5/vrb_back.png");
                        krpanoObj.set("hotspot[" + hs_name + "].ath", h);
                        krpanoObj.set("hotspot[" + hs_name + "].atv", v);
                        krpanoObj.set("hotspot[" + hs_name + "].distorted", true);
                        krpanoObj.set("hotspot[" + hs_name + "].keep", true);
                        //设置返回键的大小和透明度
                        krpanoObj.set("hotspot[" + hs_name + "].width", "50");
                        krpanoObj.set("hotspot[" + hs_name + "].height", "prop");
                        krpanoObj.set("hotspot[" + hs_name + "].alpha", 0.5);

                        if (krpanoObj.get("device.html5")) {
                            // for HTML5 it's possible to assign JS functions directly to krpanoObj events
                            krpanoObj.set("hotspot[" + hs_name + "].onclick", function (hs) {
                                if (navigator.userAgent.indexOf('iPhone') !== -1) { // iOS
                                    try {
                                        window.webkit.messageHandlers.vrbEventHandler.postMessage("exitVRMode");
                                        console.log('messageHandlers:', window.webkit.messageHandlers);
                                    } catch (err) {
                                        console.log(err)
                                    }
                                } else if (navigator.userAgent.indexOf('Android') !== -1) { // Android
                                    try {
                                        window.vrbEventHandler.exitVRMode()
                                        console.log('vrbEventHandler:', window.vrbEventHandler)
                                    } catch (err) {
                                        console.log(err)
                                    }
                                } else {
                                    alert('非法操作')
                                }

                            }.bind(null, hs_name));
                        } else {
                            // for Flash the js() action need to be used to call from Flash to JS (this code would work for Flash and HTML5)
                            krpanoObj.set("hotspot[" + hs_name + "].onclick", "js( alert(calc('hotspot \"' + name + '\" clicked')) );");
                        }

                        //循环
                        var track_mouse_enabled = false;
                        {
                            if (track_mouse_enabled == false) {
                                // enable - call 60 times per second
                                track_mouse_interval_id = setInterval(function () {
                                    var krpanoObj = document.getElementById(krpanoContainer);

                                    var hs1 = krpanoObj.get("hotspot[vrb_back_bt]");

                                    if (hs1) {
                                        if (!hs1.hovering) {
                                            //设置返回键的移动速度
                                            //var f = 0.01; // follow speed factor
                                            var f = 0.1;
                                            var h = krpanoObj.get("view.hlookat");
                                            var v = krpanoObj.get("view.vlookat");
                                            //var hsh = krpanoObj.get("hotspot[vrb_back_bt].ath");
                                            var hsh = hs1.ath;
                                            var hsv = hs1.atv;
                                            //var hsv = krpanoObj.get("hotspot[vrb_back_bt].atv");

                                            // map to -180 to +180
                                            h = (h - (h | 0)) + (((h | 0) + 360180) % 360) - 180.0;
                                            hsh = (hsh - (hsh | 0)) + (((hsh | 0) + 360180) % 360) - 180.0;

                                            // get the shortest horizontal distance
                                            dh = h - hsh;
                                            dh += (dh > 180) ? -360 : (dh < -180) ? 360 : 0

                                            // follow slowing horizontally
                                            hsh += dh * f;

                                            // fade out when farther away
                                            var a = Math.abs(v - hs1.atv) / 90.0;
                                            a = 0.5 * Math.max(1.0 - 2.0 * Math.sqrt(a), 0);

                                            // move up the more looking down
                                            v = v + 55.0 - v * 1.5;
                                            hsv = hsv * (1 - f) + v * f;

                                            // set everything
                                            //krpanoObj.set("hotspot[vrb_back_bt].alpha",a);
                                            // krpanoObj.set("hotspot[vrb_back_bt].ath",hsh);
                                            // krpanoObj.set("hotspot[vrb_back_bt].ath",hsv);
                                            //hs1.alpha = a;
                                            hs1.ath = hsh;
                                            hs1.atv = hsv;
                                        } else {
                                            hs1.alpha = 1;
                                        }
                                    }

                                }, 1000.0 / 60.0);

                                track_mouse_enabled = true;
                            } else {
                                // disable
                                clearInterval(track_mouse_interval_id);

                                track_mouse_enabled = false;
                            }
                        }
                    }
                }
            },
            removeExitBT: function (mediaType) {
                if (console.log("<**> --inject-- webvr removeExitBT =>" + mediaType),
                        krpanoContainer) {
                    var krpanoObj = document.getElementById(krpanoContainer);
                    krpanoObj && krpanoObj.get("hotspot[vrb_back_bt]") && krpanoObj.call("removehotspot('vrb_back_bt')");

                }

            },
            hideAllHotspots: function (mediaType) {
                if (console.log("<**> --inject-- webvr hideAllHotspots =>" + mediaType),
                        krpanoContainer) {
                    var krpanoObj = document.getElementById(krpanoContainer);
                    if (krpanoObj) {
                        var layerCount = krpanoObj.get("hotspot.count");
                        for (var i = layerCount - 1; i >= 0; i--) {
                            var hotspot = krpanoObj.get("hotspot[" + i + "]");
                            hotspot.visible = false;
                        }
                    }
                }

            },
            showAllHotspots: function (mediaType) {
                if (console.log("<**> --inject-- webvr showAllHotspots =>" + mediaType),
                        krpanoContainer) {
                    var krpanoObj = document.getElementById(krpanoContainer);
                    if (krpanoObj) {
                        var layerCount = krpanoObj.get("hotspot.count");
                        for (var i = layerCount - 1; i >= 0; i--) {
                            var hotspot = krpanoObj.get("hotspot[" + i + "]");
                            hotspot.visible = true;
                        }
                    }
                }

            },
            hideAllLayers: function (mediaType) {
                if (console.log("<**> --inject-- webvr hideAllLayers =>" + mediaType),
                        krpanoContainer) {
                    var krpanoObj = document.getElementById(krpanoContainer);
                    if (krpanoObj) {
                        var layerCount = krpanoObj.get("layer.count");
                        for (var i = layerCount - 1; i >= 0; i--) {
                            var layer = krpanoObj.get("layer[" + i + "]");
                            layer.visible = false;
                        }
                    }
                }
            },
            showAllLayers: function (mediaType) {
                if (console.log("<**> --inject-- webvr showAllLayers =>" + mediaType),
                        krpanoContainer) {
                    var krpanoObj = document.getElementById(krpanoContainer);
                    if (krpanoObj) {
                        var layerCount = krpanoObj.get("layer.count");
                        for (var i = layerCount - 1; i >= 0; i--) {
                            var layer = krpanoObj.get("layer[" + i + "]");
                            layer.visible = true;
                        }
                    }
                }
            },
            openBgMusic: function (mediaType) {
                if (console.log("<**> --inject-- webvr openBgMusic =>" + mediaType),
                        krpanoContainer) {
                    var krpanoObj = document.getElementById(krpanoContainer);
                    krpanoObj && krpanoObj.set("soundinterface.mute", !1);
                }
            },
            closeBgMusic: function (mediaType) {
                if (console.log("<**> --inject-- webvr closeBgMusic =>" + mediaType),
                        krpanoContainer) {
                    var krpanoObj = document.getElementById(krpanoContainer);
                    krpanoObj && krpanoObj.set("soundinterface.mute", !0);
                }
            },
            removeAllVRButtons: function (mediaType) {
                if (console.log("<**> --inject-- webvr removeAllVRButtons =>" + mediaType),
                        krpanoContainer) {
                    var krpanoObj = document.getElementById(krpanoContainer);
                    if (krpanoObj) {
                        krpanoObj.call("removelayer('" + originExitBTLayer + "');");
                        krpanoObj.call("removelayer('" + originSetupBTLayer + "');");
                    }
                }

            },
            setGlassesIPD: function (mediaType, ipdValue) {
                if (console.log("<**> --inject-- webvr removeAllVRButtons =>" + mediaType),
                        krpanoContainer) {
                    var krpanoObj = document.getElementById(krpanoContainer);
                    if (krpanoObj) {
                        krpanoObj.set("webvr.mobilevr_ipd", ipdValue);
                    }
                }
            }
        }
});

function init() {
    console.log("init => " + location.href + " " + (new Date).getTime());
    console.log("init => " + siteName + " " + (new Date).getTime());
    webvr.init();
}
var siteDetection = require("widget/siteDetection");
var siteName = siteDetection.detect().siteName;
var webvr = require("widget/webvr");
console.log("start => " + siteName + " " + (new Date).getTime());
switch (siteName) {
    case "youku":
    case "bilibili":
    case "qq":
    case "pptv":
    case "ifeng":
    case "56":
    case "wasu":
    case "cntraveler":
    case "baike":
    case "detu":
    case "quanjingke":
    case "720yun":
        window.onload = init,
            setTimeout(init, 5e3);
        break;
    case "youku-h5":
        window.onload = function () {
            console.log("bla" + (new Date).getTime()),
                setTimeout(function () {
                        init()
                    }
                    , 500)
        }
            ,
            setTimeout(init, 5e3);
        break;
    default:
        init()
}


function vrb_add_hotspot() {
    webvr.addHotspots();
}
function vrb_remove_exit_BT() {
    webvr.removeExitBT();
}
function vrb_hide_all_layer() {
    webvr.hideAllLayers();
}
function vrb_show_all_layer() {
    webvr.showAllLayers();
}

function vrb_hide_all_hotspots() {
    webvr.hideAllHotspots();
}
function vrb_show_all_hotspots() {
    webvr.showAllHotspots();
}

function vrb_show_all_UIElement() {
    vrb_show_all_hotspots();
    vrb_show_all_layer();
}
function vrb_hide_all_UIElement() {
    vrb_hide_all_hotspots();
    vrb_hide_all_layer();
}

function vrb_open_sound() {
    webvr.openBgMusic();
}
function vrb_close_sound() {
    webvr.closeBgMusic();
}
function vrb_enter_vr() {
    webvr.enterFullScreen();
}
function vrb_exit_vr() {
    webvr.exitFullScreen();
}

function vrb_hide_vr_bts() {
    webvr.removeAllVRButtons();
}
//设置瞳距
function vrb_set_glasses_paramter(ipdValue) {
    webvr.setGlassesIPD('', ipdValue);
}

function onEnterVR() {
    console.log('on enter vr');
    if (navigator.userAgent.indexOf('iPhone') !== -1) { // iOS
        try {
            window.webkit.messageHandlers.vrbEventHandler.postMessage("onEnterVR");
            console.log('messageHandlers:', window.webkit.messageHandlers);
        } catch (err) {
            console.log(err)
        }
    } else if (navigator.userAgent.indexOf('Android') !== -1) { // Android
        try {
            window.vrbEventHandler.onEnterVR();
            console.log('vrbEventHandler:', window.vrbEventHandler);
        } catch (err) {
            console.log(err);
        }
    } else {
        alert('非法操作');
    }
}

function onExitVR() {
    console.log('on exit vr');
    if (navigator.userAgent.indexOf('iPhone') !== -1) { // iOS
        try {
            window.webkit.messageHandlers.vrbEventHandler.postMessage("onExitVR");
            console.log('messageHandlers:', window.webkit.messageHandlers);
        } catch (err) {
            console.log(err)
        }
    } else if (navigator.userAgent.indexOf('Android') !== -1) { // Android
        try {
            window.vrbEventHandler.onExitVR();
            console.log('vrbEventHandler:', window.vrbEventHandler);
        } catch (err) {
            console.log(err);
        }
    } else {
        alert('非法操作');
    }
}
//测试用 获取所有layer的名字
function vrb_get_all_layer() {

    var krpanoObj = document.getElementById("krpanoSWFObject");
    if (krpanoObj) {
        var layerCount = krpanoObj.get("layer.count");
        for (var i = layerCount - 1; i >= 0; i--) {
            var hotspot = krpanoObj.get("layer[" + i + "].name");
            console.log(hotspot);
        }
    }
}
